---
title: FileReader
slug: Web/API/FileReader
tags:
  - API
  - File API
  - Files
  - Interface
  - Reference
---
<div>{{APIRef("File API")}}</div>

<p>The <strong><code>FileReader</code></strong> object lets web applications asynchronously read the contents of files (or raw data buffers) stored on the user's computer, using {{domxref("File")}} or {{domxref("Blob")}} objects to specify the file or data to read.</p>

<p>File objects may be obtained from a {{domxref("FileList")}} object returned as a result of a user selecting files using the {{HTMLElement("input")}} element, from a drag and drop operation's {{domxref("DataTransfer")}} object, or from the <code>mozGetAsFile()</code> API on an {{domxref("HTMLCanvasElement")}}.</p>

<div class="notecard warning">
<p>Important note: <code>FileReader</code> is used to read file content from the user's (remote) system in secure ways only. It cannot be used to read a file by pathname from a file system. To read files by pathname in JavaScript, standard Ajax solutions should be used to do server-side file reading, with CORS permission if reading cross-domain.</p>
</div>

<p>{{AvailableInWorkers}}</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("FileReader.FileReader", "FileReader()")}}</dt>
 <dd>Returns a newly constructed <code>FileReader</code>.</dd>
</dl>

<p>See <a href="/en-US/docs/Using_files_from_web_applications">Using files from web applications</a> for details and examples.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("FileReader.error")}} {{readonlyinline}}</dt>
 <dd>A {{domxref("DOMException")}} representing the error that occurred while reading the file.</dd>
 <dt>{{domxref("FileReader.readyState")}} {{readonlyinline}}</dt>
 <dd>A number indicating the state of the <code>FileReader</code>. This is one of the following:
 <table class="standard-table">
  <tbody>
   <tr>
    <td><code>EMPTY</code></td>
    <td><code>0</code></td>
    <td>No data has been loaded yet.</td>
   </tr>
   <tr>
    <td><code>LOADING</code></td>
    <td><code>1</code></td>
    <td>Data is currently being loaded.</td>
   </tr>
   <tr>
    <td><code>DONE</code></td>
    <td><code>2</code></td>
    <td>The entire read request has been completed.</td>
   </tr>
  </tbody>
 </table>
 </dd>
 <dt>{{domxref("FileReader.result")}} {{readonlyinline}}</dt>
 <dd>The file's contents. This property is only valid after the read operation is complete, and the format of the data depends on which of the methods was used to initiate the read operation.</dd>
</dl>

<h3 id="Event_handlers">Event handlers</h3>

<dl>
 <dt>{{domxref("FileReader.onabort")}}</dt>
 <dd>A handler for the {{event("abort")}} event. This event is triggered each time the reading operation is aborted.</dd>
 <dt>{{domxref("FileReader.onerror")}}</dt>
 <dd>A handler for the {{event("error")}} event. This event is triggered each time the reading operation encounter an error.</dd>
 <dt>{{domxref("FileReader.onload")}}</dt>
 <dd>A handler for the {{event("load")}} event. This event is triggered each time the reading operation is successfully completed.</dd>
 <dt>{{domxref("FileReader.onloadstart")}}</dt>
 <dd>A handler for the {{event("loadstart")}} event. This event is triggered each time the reading is starting.</dd>
 <dt>{{domxref("FileReader.onloadend")}}</dt>
 <dd>A handler for the {{event("loadend")}} event. This event is triggered each time the reading operation is completed (either in success or failure).</dd>
 <dt>{{domxref("FileReader.onprogress")}}</dt>
 <dd>A handler for the {{event("progress")}} event. This event is triggered while reading a {{domxref("Blob")}} content.</dd>
</dl>

<div class="note">
<p>As <code>FileReader</code> inherits from {{domxref("EventTarget")}}, all those events can also be listened for by using the {{domxref("EventTarget.addEventListener()","addEventListener")}} method.</p>
</div>

<h2 id="Methods">Methods</h2>

<dl>
 <dt>{{domxref("FileReader.abort()")}}</dt>
 <dd>Aborts the read operation. Upon return, the <code>readyState</code> will be <code>DONE</code>.</dd>
 <dt>{{domxref("FileReader.readAsArrayBuffer()")}} {{gecko_minversion_inline("7.0")}}</dt>
 <dd>Starts reading the contents of the specified {{domxref("Blob")}}, once finished, the <code>result</code> attribute contains an {{domxref("ArrayBuffer")}} representing the file's data.</dd>
 <dt>{{domxref("FileReader.readAsBinaryString()")}}</dt>
 <dd>Starts reading the contents of the specified {{domxref("Blob")}}, once finished, the <code>result</code> attribute contains the raw binary data from the file as a string.</dd>
 <dt>{{domxref("FileReader.readAsDataURL()")}}</dt>
 <dd>Starts reading the contents of the specified {{domxref("Blob")}}, once finished, the <code>result</code> attribute contains a <code>data:</code> URL representing the file's data.</dd>
 <dt>{{domxref("FileReader.readAsText()")}}</dt>
 <dd>Starts reading the contents of the specified {{domxref("Blob")}}, once finished, the <code>result</code> attribute contains the contents of the file as a text string. An optional encoding name can be specified.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to these events using {{domxref("EventTarget/addEventListener", "addEventListener()")}} or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
 <dt>{{domxref("FileReader/abort_event", "abort")}}</dt>
 <dd>Fired when a read has been aborted, for example because the program called {{domxref("FileReader.abort()")}}.<br>
 Also available via the {{domxref("FileReader/onabort", "onabort")}} property.</dd>
 <dt>{{domxref("FileReader/error_event", "error")}}</dt>
 <dd>Fired when the read failed due to an error.<br>
 Also available via the {{domxref("FileReader/onerror", "onerror")}} property.</dd>
 <dt>{{domxref("FileReader/load_event", "load")}}</dt>
 <dd>Fired when a read has completed successfully.<br>
 Also available via the {{domxref("FileReader/onload", "onload")}} property.</dd>
 <dt>{{domxref("FileReader/loadend_event", "loadend")}}</dt>
 <dd>Fired when a read has completed, successfully or not.<br>
 Also available via the {{domxref("FileReader/onloadend", "onloadend")}} property.</dd>
 <dt>{{domxref("FileReader/loadstart_event", "loadstart")}}</dt>
 <dd>Fired when a read has started.<br>
 Also available via the {{domxref("FileReader/onloadstart", "onloadstart")}} property.</dd>
 <dt>{{domxref("FileReader/progress_event", "progress")}}</dt>
 <dd>Fired periodically as data is read.<br>
 Also available via the {{domxref("FileReader/onprogress", "onprogress")}} property.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("File API", "#dfn-filereader", "FileReader")}}</td>
   <td>{{Spec2("File API")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileReader")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Using_files_from_web_applications">Using files from web applications</a></li>
 <li>{{domxref("File")}}</li>
 <li>{{domxref("Blob")}}</li>
 <li>{{domxref("FileReaderSync")}}</li>
</ul>
